// www.sgm.siedlce.pl
//
// Serwo tester 2
// 3 tryby pracy - auto, neutrum, potencjometr
// z sygnalizacją trybu jedną z 3 diod LED

#include <Servo.h> // dołączenie biblioteki
Servo myservo;     // utworzenie obiektu do sterowania serwem 

                   // deklaracje stałych i zmiennych
                   
                   // diody LED            
int led2 = 12;         // LED2 podłączony do Pin12
int led3 = 11;         // LED3 podłączony do Pin11
int led4 = 10;         // LED4 podłączony do Pin10

                   // przycisk "Tact"
int switchPin = 8;     // przycisk podłączony do Pin8
int val;               // zmienna do odczytu stanu Pin8
int buttonState;       // zmienna do przechowywania statusu przycisku
int buttonPresses = 2; // zmienna do zliczenia ilości przyciśnięć
int TstMode = 2;       // zmienna "mode testera" (1-3)

                   // serwo
int pos = 0;           // zmienna do przechowywania pozycji serwa
int posMin = 10;       // zmienne okreslające zakres wychyleń->
int posCen = 90;       // ->serwa, polożenie środkowe=90,->
int posMax = 170;      // ->maksymalny teoretyczny zakres->
                       // ->(0-179), tutaj (10-170)

                   // potencjometr  
int potpin = 0;        // suwak potencjometra podłączony do
                       // analogowego Pin0
int vPot;              // zmienna do odczytu Pin0



                  // procedura setup'u, uruchamiana jednorazowo przy
                  // starcie programu
void setup() {                
  pinMode(led2, OUTPUT);                 // ustawienie pin-ów-> 
  pinMode(led3, OUTPUT);                 // ->jako wyjść do obsługi->
  pinMode(led4, OUTPUT);                 // ->diod LED1-LED4
  pinMode(switchPin, INPUT);             // ustawienie pin-u jako wejścia
  buttonState = digitalRead(switchPin);  // odczyt stanu początkowego przycisku
  digitalWrite(led2, LOW);               // wyłączenie diody LED2
  digitalWrite(led3, HIGH);              //  włączenie diody LED3
  digitalWrite(led4, LOW);               // wyłączenie diody LED4
  myservo.attach(9);                     // programowe podłącznie serwa do
                                         // Pin9 obiektu "myservo"   
}


                   // główna pętla programu testera, obsługa diod LED i serwa
                   // z cyklicznym odczytem stanu przycisku przy pomocy
                   // podprogramu "read_SW1()" 
void loop()       
 {
   while (TstMode==1)
   {                 // obsługa trybu "mode 1" (potencjometr)
    read_SW1();
    vPot = analogRead(potpin);                 // odczyt napięcia na potentncjometrze,
                                               // wartość z zakresu (0-1023) 
    vPot = map(vPot, 0, 1023, posMin, posMax); // automatyczna konwersja odczytanej wartości
                                               // napięcia z zakresu (0-1023) na wartość z zakresu
                                               // obrotu serwa (posMin-posMax) 
    myservo.write(vPot);                       // ustaw serwo w zadaną pozycję 
   } 
  
   while (TstMode==2)
   {                 // obsługa trybu "mode 2" (centrowanie)
    read_SW1();
    myservo.write(posCen);
    pos = posCen;
   } 
  
   do 
   {                // obsługa trybu "mode 3" (auto, ruch MIN-->MAX)   
   read_SW1();
   pos++;
   myservo.write(pos); 
   } while (TstMode==3 && pos<posMax);

   do 
   {                 // obsługa trybu "mode 3" (auto, ruch MAX->MIN)  
   read_SW1();
   pos--;
   myservo.write(pos); 
   } while (TstMode==3 && pos>posMin);


 }                // koniec głównej pętli programu




                  //podprogram obsługi stanu przycisku "Tact"
                  //zliczający ilość przycisnięć do okreslenia
                  //wyboru trybu testera, praca cykliczna
                  //mode1-mode2-mode3-mode1-mode2-mode3...itd 
int read_SW1()                      
{
  val = digitalRead(switchPin);  // odczyt i zapamiętanie stanu przycisku
  delay(10);
  if (val != buttonState)        // jeśli stan się zmienił w stosunku do
                                 // odczytanego wcześniej
  {
    if (val == LOW) {            // jesli było to wcisnięcie
      buttonPresses++;           // to zwiększ licznik wciśnięć o 1
    }

    if (buttonPresses == 1) {    // jeśli licznik=1 to obsłuż "mode1"
     digitalWrite(led2, HIGH);   // zapal LED2
     digitalWrite(led3, LOW);    //  zgaś LED3
     digitalWrite(led4, LOW);    //  zgaś LED4
     TstMode = 1; 
    }

    if (buttonPresses == 2) {    // jeśli licznik=2 to obsłuż "mode2"
     digitalWrite(led2, LOW);    //  zgaś LED2
     digitalWrite(led3, HIGH);   // zapal LED3
     digitalWrite(led4, LOW);    //  zgaś LED4
     TstMode = 2;
    }

    if (buttonPresses == 3) {    // jeśli licznik=2 to obsłuż "mode3"
     digitalWrite(led2, LOW);    //  zgaś LED2
     digitalWrite(led3, LOW);    //  zgaś LED3
     digitalWrite(led4, HIGH);   // zapal LED4
     TstMode = 3; 
    }
    
  }
   
  buttonState = val;             // zapamiętaj nowy stan przycisku
  if (buttonPresses >2)          // jeśli więcej niż 3-cie wciśnięcie->
  {                              // ->to wyzeruj zmiennną (buttonPresses->
   buttonPresses = 0;            // ->przyjmuje wartości 0,1,2)
  }
  
}                    //koniec podprogramu obsługi przycisku "Tact"

